import React, { useEffect, forwardRef, useImperativeHandle, useState } from 'react';
import { View } from 'react-native';
import Skin from './components/skin';
import Body from './components/body';
import FacialHair from './components/facial-hair';
import Eyes from './components/eyes';
import Hair from './components/hair';
import Mouth from './components/mouth';
import Nose from './components/nose';
import { backgroundColors } from './constants/background';
import { facialHairColors, facialHairs } from './constants/facial-hair';
import { hairColors, hairs } from './constants/hair';
import { bodyColors, bodies } from './constants/body';
import { skinColors } from './constants/skin';
import { random, combineCharacters, parseCharacters } from './utils';
import { eyeses } from './constants/eyes';
import mouths from './constants/mouth';
import noses from './constants/nose';
function PersonasAvatar({ style, characters, onNewCharacters }, ref) {
    const [state, setState] = useState({});
    const { skinColor, hair, hairColor, body, bodyColor, facialHair, facialHairColor, eyes, mouth, nose, backgroundColor, } = state;
    useImperativeHandle(ref, () => ({
        randomize: randomAvatar,
    }));
    useEffect(() => {
        if (!characters) {
            randomAvatar();
        }
        else {
            const components = parseCharacters(characters);
            setState(components);
        }
    }, [characters]);
    function randomAvatar() {
        debugger;
        const randomCharacters = {
            skinColor: random(Object.keys(skinColors)),
            hair: random(Object.keys(hairs)),
            hairColor: random(Object.keys(hairColors)),
            facialHair: random(Object.keys(facialHairs)),
            facialHairColor: random(Object.keys(facialHairColors)),
            body: random(Object.keys(bodies)),
            bodyColor: random(Object.keys(bodyColors)),
            eyes: random(Object.keys(eyeses)),
            mouth: random(Object.keys(mouths)),
            nose: random(Object.keys(noses)),
            backgroundColor: random(Object.keys(backgroundColors)),
        };
        const characters = combineCharacters(randomCharacters);
        if (onNewCharacters) {
            onNewCharacters(characters);
        }
        setState(randomCharacters);
    }
    return (React.createElement(View, { style: [
            {
                width: 200,
                height: 200,
                borderRadius: 1000,
                overflow: 'hidden',
                backgroundColor: backgroundColors[backgroundColor] || backgroundColors.bgc1,
            },
            style,
        ] },
        React.createElement(Body, { value: body, color: bodyColors[bodyColor] }),
        React.createElement(Skin, { color: skinColors[skinColor] || skinColors.sc1 }),
        React.createElement(Hair, { value: hair, color: hairColors[hairColor] || hairColors.hc1 }),
        React.createElement(Eyes, { value: eyes }),
        React.createElement(Mouth, { value: mouth }),
        React.createElement(FacialHair, { value: facialHair, color: facialHairColors[facialHairColor] || facialHairColors.fhc1 }),
        React.createElement(Nose, { value: nose, color: skinColors[skinColor] })));
}
export default forwardRef(PersonasAvatar);
//# sourceMappingURL=personas-avatar.js.map